var T = Object.defineProperty;
var D = (o, r, t) => r in o ? T(o, r, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[r] = t;
var s = (o, r, t) => (D(o, typeof r != "symbol" ? r + "" : r, t), t);
import { move as k, hello as h, goodbye as d, cancel as v } from "hello-goodbye";
import { isFocusable as H, focusable as A } from "tabbable";
import { createFocusTrap as O } from "focus-trap";
import { autoUpdate as M, computePosition as g, shift as L, flip as x, size as K } from "@floating-ui/dom";
class I extends HTMLElement {
  constructor() {
    super(...arguments);
    s(this, "onOpen", (t) => {
      this.querySelectorAll(
        ":scope > ui-disclosure"
      ).forEach((e) => {
        e.open = e === t.target, this.required && e.toggleAttribute("disabled", e === t.target);
      });
    });
  }
  connectedCallback() {
    this.addEventListener("open", this.onOpen, { capture: !0 });
  }
  disconnectedCallback() {
    this.removeEventListener("open", this.onOpen, { capture: !0 });
  }
  get required() {
    return this.hasAttribute("required");
  }
}
const w = class extends HTMLElement {
  constructor() {
    super();
    s(this, "timeouts", /* @__PURE__ */ new Map());
    s(this, "index", 0);
    new MutationObserver((e) => {
      e.forEach((i) => {
        i.addedNodes.forEach((n) => {
          n instanceof HTMLElement && this.show(n);
        });
      });
    }).observe(this, { childList: !0 });
  }
  connectedCallback() {
    this.hasAttribute("role") || this.setAttribute("role", "status"), this.hasAttribute("aria-live") || this.setAttribute("aria-live", "polite"), this.hasAttribute("aria-relevant") || this.setAttribute("aria-relevant", "additions");
    for (const t of this.children)
      this.show(t, { animate: !1 });
  }
  show(t, e = {}) {
    const i = e.key || t.dataset.key || String(this.index++);
    t.dataset.key = i, this.contains(t) ? h(t) : e.animate === !1 ? this.append(t) : k(this.children, () => {
      this.append(t), h(t);
    });
    const n = Number(
      e.duration !== void 0 ? e.duration : t.dataset.duration || w.duration
    );
    return n > 0 && (this.startTimeout(t, n), t.addEventListener("mouseenter", this.clearTimeout.bind(this, t)), t.addEventListener("focusin", this.clearTimeout.bind(this, t)), t.addEventListener(
      "mouseleave",
      this.startTimeout.bind(this, t, n)
    ), t.addEventListener(
      "focusout",
      this.startTimeout.bind(this, t, n)
    )), i;
  }
  dismiss(t) {
    if (typeof t == "string") {
      this.querySelectorAll(
        `[data-key="${t}"]`
      ).forEach((e) => {
        this.dismiss(e);
      });
      return;
    }
    k(this.children, () => {
      d(t, {
        finish: () => this.removeChild(t)
      });
    }), this.clearTimeout(t);
  }
  clear() {
    Array.from(this.children).forEach((t) => {
      this.dismiss(t);
    });
  }
  speak(t) {
    const e = document.createElement("div");
    Object.assign(e.style, {
      clip: "rect(0 0 0 0)",
      clipPath: "inset(50%)",
      height: "1px",
      overflow: "hidden",
      position: "absolute",
      whiteSpace: "nowrap",
      width: "1px"
    }), e.textContent = t, this.show(e);
  }
  startTimeout(t, e) {
    this.clearTimeout(t), this.timeouts.set(
      t,
      window.setTimeout(() => {
        this.dismiss(t);
      }, e)
    );
  }
  clearTimeout(t) {
    this.timeouts.has(t) && clearTimeout(this.timeouts.get(t));
  }
};
let b = w;
s(b, "duration", 1e4);
function C(o) {
  return o.altKey || o.ctrlKey || o.metaKey || o.shiftKey || o.button !== void 0 && o.button !== 0;
}
class P extends HTMLElement {
  constructor() {
    super(...arguments);
    s(this, "onButtonClick", (t) => {
      !C(t) && !this.disabled && (this.open = !this.open, t.preventDefault());
    });
  }
  static get observedAttributes() {
    return ["open"];
  }
  connectedCallback() {
    this.content.hidden = !this.open, this.button.setAttribute("aria-expanded", String(this.open)), this.button.addEventListener("click", this.onButtonClick);
  }
  disconnectedCallback() {
    v(this.content), this.button.removeAttribute("aria-expanded"), this.button.removeEventListener("click", this.onButtonClick);
  }
  get open() {
    return this.hasAttribute("open");
  }
  set open(t) {
    t ? this.setAttribute("open", "") : this.removeAttribute("open");
  }
  get disabled() {
    return this.hasAttribute("disabled");
  }
  attributeChangedCallback(t, e, i) {
    t === "open" && (i !== null ? this.wasOpened() : this.wasClosed());
  }
  wasOpened() {
    this.content.hidden && (this.content.hidden = !1, h(this.content), this.button.setAttribute("aria-expanded", "true"), this.dispatchEvent(new Event("open")));
  }
  wasClosed() {
    this.content.hidden || (this.button.setAttribute("aria-expanded", "false"), d(this.content, {
      finish: () => this.content.hidden = !0
    }), this.dispatchEvent(new Event("close")));
  }
  get button() {
    return this.querySelector("button, [role=button]");
  }
  get content() {
    return this.children[1];
  }
}
const y = class extends HTMLElement {
  constructor() {
    super(...arguments);
    s(this, "search", "");
    s(this, "searchTimeout");
    s(this, "onKeyDown", (t) => {
      if (!this.hidden) {
        if (t.key === "ArrowUp") {
          this.navigate(-1), t.preventDefault();
          return;
        }
        if (t.key === "ArrowDown") {
          this.navigate(1), t.preventDefault();
          return;
        }
        t.key.length > 1 || t.ctrlKey || t.metaKey || t.altKey || (this.search += t.key.toLowerCase(), t.preventDefault(), clearTimeout(this.searchTimeout), this.searchTimeout = window.setTimeout(() => {
          this.search = "";
        }, y.searchDelay), this.items.some((e) => {
          var i;
          return ((i = e.textContent) == null ? void 0 : i.trim().toLowerCase().indexOf(this.search)) === 0 ? (e.focus(), !0) : !1;
        }));
      }
    });
  }
  connectedCallback() {
    this.hasAttribute("role") || this.setAttribute("role", "menu"), this.hasAttribute("tabindex") || this.setAttribute("tabindex", "-1"), this.items.forEach((t) => {
      t.hasAttribute("tabindex") || t.setAttribute("tabindex", "-1");
    }), this.addEventListener("keydown", this.onKeyDown);
  }
  disconnectedCallback() {
    this.removeEventListener("keydown", this.onKeyDown);
  }
  get items() {
    return Array.from(
      this.querySelectorAll("[role^=menuitem]")
    ).filter((t) => H(t));
  }
  navigate(t) {
    var n;
    const e = this.items;
    let i = (document.activeElement instanceof HTMLElement ? e.indexOf(document.activeElement) : -1) + t;
    i < 0 && (i = e.length - 1), i >= e.length && (i = 0), (n = e[i]) == null || n.focus();
  }
};
let f = y;
s(f, "searchDelay", 800);
const u = class extends HTMLElement {
  constructor() {
    super();
    s(this, "focusTrap");
    s(this, "connected", !1);
    const t = document.createElement("template");
    t.innerHTML = `
            <div part="backdrop" style="position: fixed; top: 0; left: 0; right: 0; bottom: 0"></div>
            <div part="content" style="z-index: 1"><slot></slot></div>
        `;
    const e = this.attachShadow({ mode: "open" });
    e.appendChild(t.content.cloneNode(!0)), this.backdrop.addEventListener("click", () => {
      var i;
      this.hasAttribute("static") ? (i = u.attention) == null || i.call(u, e.children[1]) : this.close();
    }), this.focusTrap = O(this, {
      escapeDeactivates: !1,
      allowOutsideClick: !0,
      preventScroll: !0
    });
  }
  static get observedAttributes() {
    return ["open"];
  }
  connectedCallback() {
    var t, e, i, n, a, E;
    this.connected = !0, (t = this.content) != null && t.hasAttribute("role") || (e = this.content) == null || e.setAttribute("role", "dialog"), (i = this.content) != null && i.hasAttribute("aria-modal") || (n = this.content) == null || n.setAttribute("aria-modal", "true"), (a = this.content) != null && a.hasAttribute("tabindex") || (E = this.content) == null || E.setAttribute("tabindex", "-1"), this.addEventListener("keydown", (p) => {
      p.key === "Escape" && this.open && (p.preventDefault(), p.stopPropagation(), this.close());
    }), this.open && this.wasOpened();
  }
  disconnectedCallback() {
    this.connected = !1;
  }
  get open() {
    return this.hasAttribute("open");
  }
  set open(t) {
    t ? this.setAttribute("open", "") : this.removeAttribute("open");
  }
  close() {
    if (!this.open)
      return;
    const t = new Event("beforeclose", { cancelable: !0 });
    this.dispatchEvent(t) && (this.open = !1);
  }
  attributeChangedCallback(t, e, i) {
    t !== "open" || !this.connected || (i !== null ? this.wasOpened() : this.wasClosed());
  }
  wasOpened() {
    var t, e;
    this.hidden = !1, h(this), (t = this.focusTrap) == null || t.activate(), (e = this.querySelector("[autofocus]")) == null || e.focus(), this.dispatchEvent(new Event("open"));
  }
  wasClosed() {
    var t;
    (t = this.focusTrap) == null || t.deactivate(), d(this, {
      finish: () => this.hidden = !0
    }), this.dispatchEvent(new Event("close"));
  }
  get backdrop() {
    var t;
    return (t = this.shadowRoot) == null ? void 0 : t.firstElementChild;
  }
  get content() {
    return this.firstElementChild;
  }
};
let m = u;
s(m, "attention", (t) => t.animate(
  [
    { transform: "scale(1)" },
    { transform: "scale(1.1)" },
    { transform: "scale(1)" }
  ],
  300
));
class $ extends HTMLElement {
  constructor() {
    super();
    s(this, "cleanup");
    s(this, "onButtonClick", (t) => {
      !C(t) && !this.disabled && (this.open = !this.open, t.preventDefault());
    });
    s(this, "onButtonKeyDown", (t) => {
      var e;
      t.key === "ArrowDown" && !this.disabled && (t.preventDefault(), this.open = !0, (e = A(this.content)[0]) == null || e.focus());
    });
    s(this, "onKeyDown", (t) => {
      t.key === "Escape" && this.open && (t.preventDefault(), t.stopPropagation(), this.open = !1, this.button.focus());
    });
    s(this, "onFocusOut", (t) => {
      (!(t.relatedTarget instanceof Node) || !this.contains(t.relatedTarget)) && (this.open = !1);
    });
    s(this, "onContentClick", (t) => {
      t.target instanceof Element && t.target.closest("[role=menuitem], [role=menuitemradio]") && (this.open = !1, this.button.focus());
    });
    const t = document.createElement("template");
    t.innerHTML = `
            <div part="backdrop" hidden style="position: fixed; top: 0; left: 0; right: 0; bottom: 0"></div>
            <slot></slot>
        `, this.attachShadow({ mode: "open" }).appendChild(t.content.cloneNode(!0)), this.backdrop.onclick = () => this.open = !1;
  }
  static get observedAttributes() {
    return ["open"];
  }
  connectedCallback() {
    this.backdrop.hidden = !0, this.content.hidden = !0, this.open = !1, this.button.setAttribute("aria-expanded", "false"), setTimeout(() => {
      this.content.getAttribute("role") === "menu" && this.button.setAttribute("aria-haspopup", "true");
    }), this.button.addEventListener("click", this.onButtonClick), this.button.addEventListener("keydown", this.onButtonKeyDown), this.addEventListener("keydown", this.onKeyDown), this.addEventListener("focusout", this.onFocusOut), this.content.addEventListener("click", this.onContentClick);
  }
  disconnectedCallback() {
    v(this.backdrop), v(this.content), this.button.removeAttribute("aria-expanded"), this.button.removeAttribute("aria-haspopup"), this.button.removeEventListener("click", this.onButtonClick), this.button.removeEventListener("keydown", this.onButtonKeyDown), this.removeEventListener("keydown", this.onKeyDown), this.removeEventListener("focusout", this.onFocusOut), this.content.removeEventListener("click", this.onContentClick);
  }
  get open() {
    return this.hasAttribute("open");
  }
  set open(t) {
    t ? this.setAttribute("open", "") : this.removeAttribute("open");
  }
  get disabled() {
    return this.hasAttribute("disabled");
  }
  attributeChangedCallback(t, e, i) {
    t === "open" && (i !== null ? this.wasOpened() : this.wasClosed());
  }
  wasOpened() {
    if (!this.content.hidden)
      return;
    this.content.hidden = !1, this.content.style.position = "absolute", this.backdrop.hidden = !1, h(this.content), h(this.backdrop), this.button.setAttribute("aria-expanded", "true"), this.cleanup = M(
      this.button,
      this.content,
      () => {
        g(this.button, this.content, {
          placement: this.getAttribute("placement") || "bottom",
          middleware: [
            L(),
            x(),
            K({
              apply: ({ availableWidth: e, availableHeight: i }) => {
                Object.assign(this.content.style, {
                  maxWidth: "",
                  maxHeight: ""
                });
                const n = getComputedStyle(this.content);
                (n.maxWidth === "none" || e < parseInt(n.maxWidth)) && (this.content.style.maxWidth = `${e}px`), (n.maxHeight === "none" || i < parseInt(n.maxHeight)) && (this.content.style.maxHeight = `${i}px`);
              }
            })
          ]
        }).then(({ x: e, y: i, placement: n }) => {
          Object.assign(this.content.style, {
            left: `${e}px`,
            top: `${i}px`
          }), this.content.dataset.placement = n;
        });
      },
      { ancestorScroll: !1 }
    );
    const t = this.content.querySelector("[autofocus]");
    t ? t.focus() : this.content.focus(), this.dispatchEvent(new Event("open"));
  }
  wasClosed() {
    var t;
    this.content.hidden || (this.button.setAttribute("aria-expanded", "false"), (t = this.cleanup) == null || t.call(this), d(this.backdrop, {
      finish: () => this.backdrop.hidden = !0
    }), d(this.content, {
      finish: () => this.content.hidden = !0
    }), this.dispatchEvent(new Event("close")));
  }
  get backdrop() {
    var t;
    return (t = this.shadowRoot) == null ? void 0 : t.firstElementChild;
  }
  get button() {
    return this.querySelector("button, [role=button]");
  }
  get content() {
    return this.children[1];
  }
}
class U extends HTMLElement {
  constructor() {
    super(...arguments);
    s(this, "onInitialFocus", () => {
      this.removeAttribute("tabindex"), this.focusControlAtIndex(0);
    });
    s(this, "onKeyDown", (t) => {
      if (t.key !== "ArrowRight" && t.key !== "ArrowLeft" && t.key !== "Home" && t.key !== "End")
        return;
      const e = this.controls, i = this.controls.length, n = e.indexOf(t.target);
      if (n === -1)
        return;
      let a = 0;
      t.key === "ArrowLeft" && (a = n - 1), t.key === "ArrowRight" && (a = n + 1), t.key === "End" && (a = i - 1), a < 0 && (a = i - 1), a > i - 1 && (a = 0), this.focusControlAtIndex(a), t.preventDefault();
    });
  }
  connectedCallback() {
    this.hasAttribute("role") || this.setAttribute("role", "toolbar"), this.setAttribute("tabindex", "0"), this.addEventListener("focus", this.onInitialFocus, { once: !0 }), this.addEventListener("keydown", this.onKeyDown);
  }
  disconnectedCallback() {
    this.removeEventListener("keydown", this.onKeyDown);
  }
  focusControlAtIndex(t) {
    this.controls.forEach((e, i) => {
      i === t ? (e.setAttribute("tabindex", "0"), e.focus()) : e.setAttribute("tabindex", "-1");
    });
  }
  get controls() {
    return A(this);
  }
}
const l = class extends HTMLElement {
  constructor() {
    super(...arguments);
    s(this, "parent");
    s(this, "tooltip");
    s(this, "timeout");
    s(this, "observer");
    s(this, "showing", !1);
    s(this, "onMouseEnter", this.afterDelay.bind(this, this.show));
    s(this, "onFocus", this.show.bind(this));
    s(this, "onMouseLeave", this.afterDelay.bind(this, this.hide));
    s(this, "onBlur", this.hide.bind(this));
    s(this, "onPointerUp", (t) => {
      t.pointerType === "mouse" ? this.hide() : this.show();
    });
    s(this, "onKeyDown", (t) => {
      t.key === "Escape" && this.hide();
    });
  }
  connectedCallback() {
    this.parent = this.parentNode, this.parent && (this.parent.addEventListener("mouseenter", this.onMouseEnter), this.parent.addEventListener("focus", this.onFocus), this.parent.addEventListener("mouseleave", this.onMouseLeave), this.parent.addEventListener("blur", this.onBlur), this.parent.addEventListener("pointerup", this.onPointerUp), this.observer = new MutationObserver((t) => {
      t.forEach((e) => {
        e.attributeName === "disabled" && this.hide();
      });
    }), this.observer.observe(this.parent, { attributes: !0 })), document.addEventListener("keydown", this.onKeyDown), document.addEventListener("scroll", this.onBlur);
  }
  disconnectedCallback() {
    var t;
    this.tooltip && (this.tooltip.remove(), this.tooltip = void 0), this.parent && (this.parent.removeEventListener("mouseenter", this.onMouseEnter), this.parent.removeEventListener("focus", this.onFocus), this.parent.removeEventListener("mouseleave", this.onMouseLeave), this.parent.removeEventListener("blur", this.onBlur), this.parent.removeEventListener("pointerup", this.onPointerUp), this.parent = void 0), document.removeEventListener("keydown", this.onKeyDown), document.removeEventListener("scroll", this.onBlur), (t = this.observer) == null || t.disconnect(), clearTimeout(this.timeout);
  }
  get disabled() {
    return this.hasAttribute("disabled");
  }
  set disabled(t) {
    t ? this.setAttribute("disabled", "") : this.removeAttribute("disabled");
  }
  show() {
    if (this.disabled)
      return;
    const t = this.createTooltip();
    clearTimeout(this.timeout), this.showing || (t.hidden = !1, h(t), this.showing = !0), t.innerHTML !== this.innerHTML && (t.innerHTML = this.innerHTML), t.style.position = "absolute", g(this.parent, t, {
      placement: this.getAttribute("placement") || l.placement,
      middleware: [L(), x()]
    }).then(({ x: e, y: i, placement: n }) => {
      Object.assign(t.style, {
        left: `${e}px`,
        top: `${i}px`
      }), t.dataset.placement = n;
    });
  }
  hide() {
    clearTimeout(this.timeout), this.showing && (this.showing = !1, d(this.tooltip, {
      finish: () => {
        this.tooltip && (this.tooltip.hidden = !0);
      }
    }));
  }
  afterDelay(t) {
    clearTimeout(this.timeout);
    const e = parseInt(this.getAttribute("delay") || "");
    this.timeout = window.setTimeout(
      t.bind(this),
      isNaN(e) ? l.delay : e
    );
  }
  createTooltip() {
    return this.tooltip || (this.tooltip = document.createElement("div"), this.tooltip.className = this.getAttribute("tooltip-class") || l.tooltipClass, this.tooltip.hidden = !0, this.tooltip.addEventListener("mouseenter", this.show.bind(this)), this.tooltip.addEventListener(
      "mouseleave",
      this.afterDelay.bind(this, this.hide)
    ), document.body.appendChild(this.tooltip)), this.tooltip;
  }
};
let c = l;
s(c, "delay", 100), s(c, "placement", "top"), s(c, "tooltipClass", "tooltip");
export {
  I as AccordionElement,
  b as AlertsElement,
  P as DisclosureElement,
  f as MenuElement,
  m as ModalElement,
  $ as PopupElement,
  U as ToolbarElement,
  c as TooltipElement
};
